<template>
  <Header />
  <Timer @save-timer="addTimer" />
  <History :timers="timerHistory" @delete-timer="deleteTimer" />
</template>

<script>
import Header from "./components/Header.vue";
import Timer from "./components/Timer/Timer.vue";
import History from "./components/History/History.vue";

function* IDGenerator(lastID = 0) {
  let i = lastID;

  while (true) {
    yield i++;
  }
}

let IDIterator;

export default {
  name: "App",
  components: {
    Header,
    Timer,
    History,
  },
  data() {
    return {
      timerHistory: [],
    };
  },
  methods: {
    async addTimer(timer) {
      const newTimer = {
        id: IDIterator.next().value,
        timer,
        date: new Date(),
      };

      const response = await fetch(`http://localhost:3000/timers`, {
        method: "POST",
        headers: [["content-type", "application/json"]],
        body: JSON.stringify({ ...newTimer, date: newTimer.date.getTime() }),
      });

      if (response.ok) {
        this.timerHistory.push(newTimer);
      }
    },
    async deleteTimer(id) {
      const response = await fetch(`http://localhost:3000/timers/${id}`, {
        method: "DELETE",
      });

      if (response.ok) {
        this.timerHistory = this.timerHistory.filter(
          (timer) => timer.id !== id
        );
      }
    },
  },
  async created() {
    const response = await fetch("http://localhost:3000/timers");
    const timersArray = await response.json();

    this.timerHistory = timersArray.map((timer) => ({
      ...timer,
      date: new Date(timer.date),
    }));
  },

  mounted() {
    IDIterator = IDGenerator(
      this.timerHistory[this.timerHistory.length - 1]?.id
    );
  },
};
</script>

<style>
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

body {
  display: flex;
  justify-content: center;
}

#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
  display: grid;
  grid-template-rows: 1fr 0.5fr auto;
  max-width: 800px;
}
</style>
